--------------------------------------------------------------------------------
-- Company:       CERN, BE-CO-HT
-- Engineer:      Carlos Gil Soriano
--
-- Create Date:   10:59:15 10/31/2011
-- Design Name:   
-- Module Name:   /media/BACKUP/CERN/contrib/ohwr/conv-ttl-blo/hdl/rtl/i2c_slave_wb_master/test/i2c_slave_top_tb.vhd
-- Project Name:  i2c_slave_wb_master
-- Target Device: Spartan 6
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: i2c_slave_top
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Revision 0.1  - File Modified. Now the sda_i line is more acurately accessed.
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
library IEEE;
library work;

use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALl;
use std.textio.ALL;
use work.i2c_tb_pkg.ALL;
use work.wishbone_driver_pkg.ALL;
 
entity i2c_slave_top_tb is
end i2c_slave_top_tb;
 
architecture behavior of i2c_slave_top_tb is 

   --! Connections for i2c_slave_top
   signal sda_slave_oen     : STD_LOGIC;
   signal sda_slave_i       : STD_LOGIC := '1';
   signal sda_slave_o       : STD_LOGIC;
   signal scl_slave_oen     : STD_LOGIC;
   signal scl_slave_i       : STD_LOGIC := '1';
   signal scl_slave_clk     : STD_LOGIC := '1';
   signal scl_slave_o       : STD_LOGIC;

   signal wb_clk            : STD_LOGIC := '0';
   signal wb_rst_i          : STD_LOGIC := '0';

   signal wb_master_stb_o   : STD_LOGIC;
   signal wb_master_cyc_o   : STD_LOGIC;
   signal wb_master_sel_o   : STD_LOGIC_VECTOR (3  downto 0);
   signal wb_master_we_o    : STD_LOGIC;
   signal wb_master_data_i  : STD_LOGIC_VECTOR (31 downto 0) := X"00000000";
   signal wb_master_data_o  : STD_LOGIC_VECTOR (31 downto 0);
   signal wb_master_addr_o  : STD_LOGIC_VECTOR (15  downto 0);
   signal wb_master_ack_i   : STD_LOGIC := '0';
   signal wb_master_rty_i   : STD_LOGIC := '0';
   signal wb_master_err_i   : STD_LOGIC := '0';

   signal wb_slave_cyc_i    : STD_LOGIC := '0';
   signal wb_slave_stb_i    : STD_LOGIC;
   signal wb_slave_sel_i    : STD_LOGIC_VECTOR (3  downto 0) := X"0";
   signal wb_slave_we_i     : STD_LOGIC := '0';
   signal wb_slave_data_i   : STD_LOGIC_VECTOR (31 downto 0) := X"00000000";
   signal wb_slave_data_o   : STD_LOGIC_VECTOR (31 downto 0);
   signal wb_slave_addr_i   : STD_LOGIC_VECTOR (3  downto 0) := X"0";
   signal wb_slave_ack_o    : STD_LOGIC;
   signal wb_slave_rty_o    : STD_LOGIC;
   signal wb_slave_err_o    : STD_LOGIC;

   signal pf_wb_addr_o      : STD_LOGIC;
   signal rd_done_o         : STD_LOGIC;
   signal wr_done_o         : STD_LOGIC;
   signal i2c_addr_i        : STD_LOGIC_VECTOR (6 downto 0);

   --! Connections for the wishbone driver
   signal s_data_i          : STD_LOGIC_VECTOR(31 downto 0) := (others => '0');
   signal s_data_o          : STD_LOGIC_VECTOR(31 downto 0);
   signal s_addr_i          : STD_LOGIC_VECTOR(3 downto 0)  := (others => '0');

   signal write_i           : STD_LOGIC := '0'; 
   signal write_done_o      : STD_LOGIC; 
   signal read_i            : STD_LOGIC := '0'; 
   signal read_done_o       : STD_LOGIC; 


   signal s_i2c_addr_op     : STD_LOGIC_VECTOR(7 downto 0)
                                        := (others => '0');
   signal s_wishbone_addr   : STD_LOGIC_VECTOR(c_WB_ADDR_LENGTH - 1 downto 0)
                                        := (others => '0');
   signal s_wr_data         : STD_LOGIC_VECTOR(c_WR_DATA_LENGTH - 1 downto 0)
                                        := (others => '0');
   signal s_rd_data         : STD_LOGIC_VECTOR(c_RD_DATA_LENGTH - 1 downto 0);

   signal s_start           : STD_LOGIC := '0';
   signal s_start_done      : STD_LOGIC;
   signal s_pause           : STD_LOGIC := '0';
   signal s_pause_done      : STD_LOGIC;
   signal s_write           : STD_LOGIC := '0';
   signal s_write_done      : STD_LOGIC;
   signal s_read            : STD_LOGIC := '0';
   signal s_read_done       : STD_LOGIC;

begin 

   i2c_addr_i(6 downto 5)   <= "00";
   i2c_addr_i(4 downto 0)   <= std_logic_vector(c_VME_SLOT);

	-- Instantiate the Unit Under Test (UUT)
   uut: i2c_slave_top
   port map (sda_oen     => sda_slave_oen,
             sda_i       => sda_slave_i,
             sda_o       => sda_slave_o,
             scl_oen     => scl_slave_oen,
             scl_i       => scl_slave_i,
             scl_o       => scl_slave_o,

             wb_clk      => wb_clk,
             wb_rst_i    => wb_rst_i,

             wb_master_stb_o   => wb_master_stb_o, 
             wb_master_cyc_o   => wb_master_cyc_o, 
             wb_master_sel_o   => wb_master_sel_o, 
             wb_master_we_o    => wb_master_we_o, 
             wb_master_data_i  => wb_master_data_i, 
             wb_master_data_o  => wb_master_data_o, 
             wb_master_addr_o  => wb_master_addr_o, 
             wb_master_ack_i   => wb_master_ack_i, 
             wb_master_rty_i   => wb_master_rty_i, 
             wb_master_err_i   => wb_master_err_i, 

             wb_slave_stb_i    => wb_slave_stb_i,
             wb_slave_cyc_i    => wb_slave_cyc_i,
             wb_slave_sel_i    => wb_slave_sel_i,
             wb_slave_we_i     => wb_slave_we_i,
             wb_slave_data_i   => wb_slave_data_i,
             wb_slave_data_o   => wb_slave_data_o,
             wb_slave_addr_i   => wb_slave_addr_i,
             wb_slave_ack_o    => wb_slave_ack_o,
             wb_slave_rty_o    => wb_slave_rty_o,
             wb_slave_err_o    => wb_slave_err_o,

             pf_wb_addr_o      => pf_wb_addr_o,
             rd_done_o         => rd_done_o,
             wr_done_o         => wr_done_o,
             i2c_addr_i        => i2c_addr_i);
    

   i2c_driver: i2c_master_driver
   port map(tb_clk           => wb_clk,
              
            sda_master_i     => sda_slave_o, 
            sda_master_o     => sda_slave_i, 
            scl_master_o     => scl_slave_i, 
  
            i2c_addr_op_i    => s_i2c_addr_op, 
            wishbone_addr_i  => s_wishbone_addr, 
            wr_data_i        => s_wr_data, 
            rd_data_o        => s_rd_data,

            start_i          => s_start, 
            start_done_o     => s_start_done, 
            pause_i          => s_pause, 
            pause_done_o     => s_pause_done, 
            write_i          => s_write, 
            write_done_o     => s_write_done, 
            read_i           => s_read, 
            read_done_o      => s_read_done); 


   wb_driver:  wishbone_driver
   generic map(g_WB_ADDR_LENGTH   => wb_slave_addr_i'length,
               g_WB_CLK_PERIOD    => c_WB_CLK_PERIOD)
   port map(wb_clk_i     => wb_clk,
            wb_rst_i     => wb_rst_i,

            wb_stb_o     => wb_slave_stb_i,
            wb_cyc_o     => wb_slave_cyc_i,
            wb_sel_o     => wb_slave_sel_i,
            wb_we_o      => wb_slave_we_i, 
            wb_data_i    => wb_slave_data_o,
            wb_data_o    => wb_slave_data_i,
            wb_addr_o    => wb_slave_addr_i,
            wb_ack_i     => wb_slave_ack_o,
            wb_rty_i     => wb_slave_rty_o,
            wb_err_i     => wb_slave_err_o,

            data_i       => s_data_i,
            data_o       => s_data_o,
            addr_i       => s_addr_i,

            write_i      => write_i,
            write_done_o => write_done_o,
            read_i       => read_i,
            read_done_o  => read_done_o);


   --! Clock process definitions
   wb_clk_process :process
   begin
      wb_clk <= '1';
        wait for c_WB_CLK_PERIOD/2;
      wb_clk <= '0';
        wait for c_WB_CLK_PERIOD/2;
   end process;

   --! Stimulus process
   p_i2c_tb: process

      procedure start_I2C is
      begin
         s_start <= '1';
           wait until rising_edge(s_start_done);
           wait until rising_edge(wb_clk);
         s_start <= '0';
      end procedure;

      procedure write_I2C(i2c_addr   : STD_LOGIC_VECTOR(7 downto 0);
            wb_addr : STD_LOGIC_VECTOR(s_wishbone_addr'length - 1 downto 0);
            wr_data : STD_LOGIC_VECTOR(s_wr_data'length       - 1 downto 0)) is
      begin
           wait until rising_edge(wb_clk);
         s_i2c_addr_op     <= i2c_addr;
         s_wishbone_addr   <= wb_addr;
         s_wr_data         <= wr_data;
         s_write <= '1';
           wait until rising_edge(wb_clk);
         s_write <= '0';
           wait until rising_edge(s_write_done);
           wait until rising_edge(wb_clk);
      end procedure;

      --! This procedure is a wrapper in case we want to address with VME
      --! directions. Front padding is done with zeroes.
      procedure write_I2C(vme_slot   : UNSIGNED(4 downto 0);
            wb_addr : STD_LOGIC_VECTOR(s_wishbone_addr'length - 1 downto 0);
            wr_data : STD_LOGIC_VECTOR(s_wr_data'length       - 1 downto 0)) is
         variable v_i2c_addr  : STD_LOGIC_VECTOR(7 downto 0);
      begin
         v_i2c_addr(7 downto 5) := "000";
         v_i2c_addr(4 downto 0) := STD_LOGIC_VECTOR(vme_slot);
         write_I2C(v_i2c_addr, wb_addr, wr_data);
      end procedure;

   begin
      wb_rst_i <= '1';
        wait for c_WB_CLK_PERIOD*10;
      wb_rst_i <= '0';
      start_I2C;
      write_I2C(c_VME_SLOT, X"BABE", X"B16B00B5");
        wait for c_WB_CLK_PERIOD*25;
   end process;

end;
